routes/web.php
<?php


/* --------------------- Common/User Routes START -------------------------------- */

Route::get('/', function () {
    // return view('welcome');
    return redirect('admin/dashboard');
});

Auth::routes(['verify' => true]);

Route::get('/home', 'HomeController@index')->name('home')->middleware('verified');

/* --------------------- Common/User Routes END -------------------------------- */

/* ----------------------- Admin Routes START -------------------------------- */

Route::prefix('/admin')->name('admin.')->namespace('Admin')->group(function () {

    /**
     * Admin Auth Route(s)
     */
    Route::namespace('Auth')->group(function () {

        //Login Routes
        Route::get('/login', 'LoginController@showLoginForm')->name('login');
        Route::post('/login', 'LoginController@login');
        Route::post('/logout', 'LoginController@logout')->name('logout');

        //Register Routes
        // Route::get('/register','RegisterController@showRegistrationForm')->name('register');
        // Route::post('/register','RegisterController@register');

        //Forgot Password Routes
        Route::get('/password/reset', 'ForgotPasswordController@showLinkRequestForm')->name('password.request');
        Route::post('/password/email', 'ForgotPasswordController@sendResetLinkEmail')->name('password.email');

        //Reset Password Routes
        Route::get('/password/reset/{token}', 'ResetPasswordController@showResetForm')->name('password.reset');
        Route::post('/password/reset', 'ResetPasswordController@reset')->name('password.update');

        // Email Verification Route(s)
        Route::get('email/verify', 'VerificationController@show')->name('verification.notice');
        Route::get('email/verify/{id}', 'VerificationController@verify')->name('verification.verify');
        Route::get('email/resend', 'VerificationController@resend')->name('verification.resend');
    });

    Route::get('/dashboard', 'HomeController@index')->name('home');
    Route::get('/settings', 'HomeController@settings')->name('settings');
    Route::post('/updateSettings', 'HomeController@updateSettings')->name('updateSettings');

    // User Management
    Route::get('/users', 'UserController@index')->name('user');
    Route::get('/getUserListings', 'UserController@getUserListings')->name('getUserListings');
    Route::get('/user/{id}', 'UserController@show')->name('user.show');
    Route::get('/user/{id}/edit', 'UserController@edit')->name('user.edit');
    Route::post('/user/{id}/edit', 'UserController@doEdit')->name('user.do-edit');
    Route::get('/user/{id}/delete', 'UserController@delete')->name('user.delete');

    // NPO Management
    Route::get('/npo-listings', 'NPOController@index')->name('npo');
    Route::get('/getNPOListings', 'NPOController@getNPOListings')->name('getNPOListings');
    Route::get('/add-npo', 'NPOController@add')->name('npo.add');
    Route::post('/addNpo', 'NPOController@addNpo')->name('npo.do-addNpo');
    Route::get('/npo/{id}', 'NPOController@show')->name('npo.show');
    Route::get('/npo/{id}/edit', 'NPOController@edit')->name('npo.edit');
    Route::post('/npo/{id}/edit', 'NPOController@doEdit')->name('npo.do-edit');
    Route::get('/npo/{id}/delete', 'NPOController@delete')->name('npo.delete');

    // NPO Categories
    Route::get('/npo-categories', 'NpoCategoriesController@index')->name('npocategories');
    Route::get('/getNPOCategoryListings', 'NpoCategoriesController@getNPOCategoryListings')->name('getNPOCategoryListings');
    Route::get('/add-npo-category', 'NpoCategoriesController@create')->name('npocategories.add-npo-category');
    Route::post('/createNpoCategory', 'NpoCategoriesController@createNpoCategory')->name('createNpoCategory');
    Route::get('/npo-categories/{id}/edit', 'NpoCategoriesController@edit')->name('npocategories.edit-npo-category');
    Route::post('/npo-categories/{id}/edit', 'NpoCategoriesController@updateNpoCategory')->name('updateNpoCategory');


    // NPO Coupons
    Route::get('/coupons', 'CouponController@index')->name('coupons');
    Route::get('/getCouponListings', 'CouponController@getCouponListings')->name('getCouponListings');
    Route::get('/add-coupon', 'CouponController@create')->name('coupons.add-coupon');
    Route::post('/createCoupon', 'CouponController@createCoupon')->name('createCoupon');
    Route::get('/coupons/{id}/edit', 'CouponController@edit')->name('coupons.edit-coupon');
    Route::post('/coupons/{id}/edit', 'CouponController@updateCoupon')->name('updateCoupon');   

    // Giveaways
    Route::get('/giveaways', 'GiveawaysController@index')->name('giveaways');
    Route::get('/getGiveawaysListings', 'GiveawaysController@getGiveawaysListings')->name('getGiveawaysListings');
    Route::get('/add-giveaway', 'GiveawaysController@create')->name('giveaways.add-giveaway');
    Route::post('/createGiveaway', 'GiveawaysController@createGiveaway')->name('createGiveaway');
    Route::get('/giveaways/{id}/edit', 'GiveawaysController@edit')->name('giveaways.edit-giveaway');
    Route::post('/giveaways/{id}/edit', 'GiveawaysController@updateGiveaway')->name('updateGiveaway'); 


    // Champions
    Route::get('/champions', 'ChampionsController@index')->name('champions');
    Route::get('/getChampionsListings', 'ChampionsController@getChampionsListings')->name('getChampionsListings');
    Route::get('/add-champion', 'ChampionsController@create')->name('champions.add-champion');
    Route::post('/createChampion', 'ChampionsController@createChampion')->name('createChampion');
    Route::get('/champions/{id}/edit', 'ChampionsController@edit')->name('champions.edit-champion');
    Route::post('/champions/{id}/edit', 'ChampionsController@updateChampion')->name('updateChampion'); 


    //Put all of your admin routes here...

});

/* ----------------------- Admin Routes END -------------------------------- */

app/Http/Controllers/Admin/NpoCategoriesController.php
<?php

namespace App\Http\Controllers\Admin;


use App\NpoCategories;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Yajra\DataTables\Facades\DataTables;
use App\Traits\UploadTrait; // Upload Image



class NpoCategoriesController extends Controller
{

    use UploadTrait;

    /**
     * Only Authenticated users for "admin" guard 
     * are allowed.
     * 
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth:admin');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('admin.npocategories.index');
    }

    public function getNPOCategoryListings()
    {
        $getNpoCategories = NpoCategories::select('*');
        return DataTables::eloquent($getNpoCategories)
            ->addColumn('category_image', function ($data) {
                return $this->getCategoryImage($data->category_image);
            })
            ->addColumn('action', 'admin.npocategories.action')
            ->rawColumns(['action', 'category_image'])
            ->toJson();
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.npocategories.create');
    }



    public function createNpoCategory(Request $request)
    {

        $newCategory = new NpoCategories;

        $request->validate([
            'category_name' => 'required',
            'category_image' => 'image|mimes:jpeg,png,jpg,gif',

        ]);


        // Check if a profile image has been uploaded
        if ($request->has('category_image')) {
            // Get image file
            $image = $request->file('category_image');
            // Make a image name based on user name and current timestamp
            $name = 'npo_category_' . time();
            // Define folder path
            $folder = '/app-assets/admin/categories/';
            // Make a file path where image will be stored [ folder path + file name + file extension]
            $filePath = $folder . $name . '.' . $image->getClientOriginalExtension();
            // Upload image
            $this->uploadOne($image, $folder, 'public', $name);
            // Set user profile image path in database to filePath
            $newCategory->category_image = $filePath;
        }

        $newCategory->category_name = $request->input('category_name');
        $newCategory->category_slug = $this->createSlug($request->input('category_name'));
        $newCategory->save();

        return redirect()
            ->intended(route('admin.npocategories'))
            ->with('status', $request->input('category_name') . ' category added successfully.');
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $catById = NpoCategories::find($id);
        return view('admin.npocategories.edit', compact('catById'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function updateNpoCategory(Request $request, $id)
    {
        $updateCat = NpoCategories::find($id);

        $request->validate([
            'category_name' => 'required',
            'category_status' => 'required',
            'category_image' => 'image|mimes:jpeg,png,jpg,gif',

        ]);


        // Check if a profile image has been uploaded
        if ($request->has('category_image')) {
            // Get image file
            $image = $request->file('category_image');
            // Make a image name based on user name and current timestamp
            $name = 'npo_category_' . time();
            // Define folder path
            $folder = '/app-assets/admin/categories/';
            // Make a file path where image will be stored [ folder path + file name + file extension]
            $filePath = $folder . $name . '.' . $image->getClientOriginalExtension();
            // Upload image
            $this->uploadOne($image, $folder, 'public', $name);
            // Set user profile image path in database to filePath
            $updateCat->category_image = $filePath;
        }

        $updateCat->category_name = $request->input('category_name');
        $updateCat->category_status = $request->input('category_status');
        $updateCat->category_slug = $this->createSlug($request->input('category_name'));
        $updateCat->update();

        return redirect()
            ->intended(route('admin.npocategories'))
            ->with('status', $request->input('category_name') . ' category updated successfully.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }

    public function createSlug($str, $delimiter = '-')
    {

        $slug = strtolower(trim(preg_replace('/[\s-]+/', $delimiter, preg_replace('/[^A-Za-z0-9-]+/', $delimiter, preg_replace('/[&]/', 'and', preg_replace('/[\']/', '', iconv('UTF-8', 'ASCII//TRANSLIT', $str))))), $delimiter));
        return $slug;
    }

    public function getCategoryImage($category_image){
        $defaultImagePath = 'app-assets/admin/dist/img/noImage.png';
        if($category_image){
            return '<img class="images_avatar" src = "'.asset($category_image).'" >';
        }else{
            return '<img class="images_avatar" src = "'.asset($defaultImagePath ) .'" >';
        }

    }
}

resources/views/admin/npocategories/action.blade.php
<div class="text-center">    

    <a class="btn btn-info btn-sm" href="{{ route('admin.npocategories.edit-npo-category', $id) }}">
        <i class="fas fa-pencil-alt">
        </i>
        Edit
    </a>   
</div>

resources/views/admin/npocategories/create.blade.php
@extends('layouts.app')
@section('content')
<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <div class="container-fluid">
            <div class="row mb-2">
                <div class="col-sm-6">
                    <h1>Add Category</h1>
                </div>
                <div class="col-sm-6">
                    <ol class="breadcrumb float-sm-right">
                        <li class="breadcrumb-item"><a href="#">Home</a></li>
                        <li class="breadcrumb-item active">Add Category</li>
                    </ol>
                </div>
            </div>
        </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
        <div class="row">
            <div class="col-md-12">
                <div class="card card-primary">
                    
                    <div class="card-body">
                        <form method="post" enctype="multipart/form-data" action="{{ route('admin.createNpoCategory') }}">
                            {{ csrf_field() }}
                            <div class="form-group">
                                <label for="inputName">Category Name</label>
                                <input type="text" name="category_name" id="inputCategoryName" class="form-control {{ $errors->has('category_name') ? 'is-invalid' : '' }}" value="">

                                @if($errors->has('category_name'))
                                <span class="invalid-feedback">
                                    {{ $errors->first('category_name') }}
                                </span>
                                @endif
                            </div>   
                            
                            <div class="form-group">
                                <label for="inputName">Category Image</label>
                                <input type="file" name="category_image" id="inputCategoryName" class="{{ $errors->has('category_image')  ? 'is-invalid' : '' }}" value="">

                                @if($errors->has('category_image'))
                                <span class="invalid-feedback">
                                    {{ $errors->first('category_image') }}
                                </span>
                                @endif
                            </div> 
                            

                            <div class="col-12">
                                <a href="{{ route('admin.npocategories') }}" class="btn btn-secondary">Cancel</a>
                                <input type="submit" value="Add" class="btn btn-success float-right">
                            </div>
                        </form>
                    </div>
                    <!-- /.card-body -->
                </div>
                <!-- /.card -->
            </div>

        </div>

    </section>
    <!-- /.content -->
</div>
<!-- /.content-wrapper -->
@endsection

resources/views/admin/npocategories/edit.blade.php
@extends('layouts.app')
@section('content')
<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <div class="container-fluid">
            <div class="row mb-2">
                <div class="col-sm-6">
                    <h1>Edit Category</h1>
                </div>
                <div class="col-sm-6">
                    <ol class="breadcrumb float-sm-right">
                        <li class="breadcrumb-item"><a href="#">Home</a></li>
                        <li class="breadcrumb-item active">Edit Category</li>
                    </ol>
                </div>
            </div>
        </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
        <div class="row">
            <div class="col-md-12">
                <div class="card card-primary">
                    
                    <div class="card-body">
                        <form method="post" enctype="multipart/form-data" action="{{ route('admin.updateNpoCategory', $catById->id) }}">
                            {{ csrf_field() }}
                            <div class="form-group">
                                <label for="inputName">Category Name</label>
                                <input type="text" name="category_name" id="inputCategoryName" class="form-control {{ $errors->has('category_name') ? 'is-invalid' : '' }}" value="{{ old('category_name',$catById->category_name) }}">

                                @if($errors->has('category_name'))
                                <span class="invalid-feedback">
                                    {{ $errors->first('category_name') }}
                                </span>
                                @endif
                            </div> 
                            
                            <div class="form-group">
                                <label for="inputStatus">Status</label>
                                <select name="category_status" class="form-control custom-select">
                                    <option selected disabled>Select one</option>
                                    <option {{ old( 'category_status', $catById->category_status ) == 'active' ? 'selected' : '' }} value="active">Active</option>
                                    <option {{ old( 'category_status', $catById->category_status ) == 'inactive' ? 'selected' : '' }} value="inactive">Inactive</option>
                                </select>
                            </div>
                            
                            <div class="form-group">
                                <label for="inputName">Category Image</label>
                                <input type="file" name="category_image" id="inputCategoryName" class="{{ $errors->has('category_image')  ? 'is-invalid' : '' }}" value="">

                                @if($errors->has('category_image'))
                                <span class="invalid-feedback">
                                    {{ $errors->first('category_image') }}
                                </span>
                                @endif
                            </div> 

                            <div class="form-group">
                                @if ($catById->category_image)
                                <img src="{{ asset($catById->category_image) }}" style="width: 100px; height: 100px;">
                                @endif
                            </div>

                            
                            

                            <div class="col-12">
                                <a href="{{ route('admin.npocategories') }}" class="btn btn-secondary">Cancel</a>
                                <input type="submit" value="Update" class="btn btn-success float-right">
                            </div>
                        </form>
                    </div>
                    <!-- /.card-body -->
                </div>
                <!-- /.card -->
            </div>

        </div>

    </section>
    <!-- /.content -->
</div>
<!-- /.content-wrapper -->
@endsection

resources/views/admin/npocategories/index.blade.php
@extends('layouts.app')


@section('header')
<!-- DataTables -->
<link rel="stylesheet" href="{{asset('app-assets/admin/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css')}}">
<link rel="stylesheet" href="{{asset('app-assets/admin/plugins/datatables-responsive/css/responsive.bootstrap4.min.css')}}">
@endsection

@section('content')


<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <div class="container-fluid">
            <div class="row mb-2">
                <div class="col-sm-6">
                    <h1>NPO Categories</h1>
                </div>
                <div class="col-sm-6">
                    <ol class="breadcrumb float-sm-right">
                        <li class="breadcrumb-item"><a href="#">Home</a></li>
                        <li class="breadcrumb-item active">Categories</li>
                    </ol>
                </div>
            </div>
            <div class="row">
                <div class="col-sm-2 float-sm-right">
                    <a class="btn btn-block btn-info " href="{{ route('admin.npocategories.add-npo-category') }}">
                        {{ __('Add New Category') }}
                    </a>

                </div>
            </div>
        </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
        <div class="row">
            <div class="col-12">
                <div class="card">

                    <div class="card-body" id="admin-categories-list-wrap">
                        <table id="table-manage-categories" class="table table-bordered table-striped" data-url="{{ route('admin.getNPOCategoryListings') }}">
                            <thead>
                                <tr>
                                    <th>#</th>
                                    <th>Image</th>
                                    <th>Name</th>
                                    <th>Status</th>
                                    <th>Action</th>
                                </tr>
                            </thead>

                        </table>
                    </div>
                    <!-- /.card-body -->
                </div>
                <!-- /.card -->
            </div>
            <!-- /.col -->
        </div>
        <!-- /.row -->
    </section>
    <!-- /.content -->
</div>
<!-- /.content-wrapper -->



@endsection

@section('footer')
<!-- DataTables -->
<script src="{{asset('app-assets/admin/plugins/datatables/jquery.dataTables.min.js')}}"></script>
<script src="{{asset('app-assets/admin/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js')}}"></script>
<script src="{{asset('app-assets/admin/plugins/datatables-responsive/js/dataTables.responsive.min.js')}}"></script>
<script src="{{asset('app-assets/admin/plugins/datatables-responsive/js/responsive.bootstrap4.min.js')}}"></script>
<script src="{{asset('app-assets/admin/pages/npocategory.js')}}"></script>
@endsection